import { IWebAppAPI } from '@cloudbase/weda-client';
import { UserWidget } from '../utils';
interface IBaseState {
    state: {
        [key: string]: any;
    };
    computed: {
        [key: string]: any;
    };
    dataset?: {
        state?: {};
        params?: {};
        query?: {};
    };
}
export declare const subPackageName = "";
export declare const $w: any;
export declare let app: any;
export declare function registerApp(_app?: IAppAPI): void;
export interface IAppAPI extends IWebAppAPI, IBaseState {
    domain: string;
    app?: IAppAPI;
    $app?: IAppAPI;
    mainApp?: IAppAPI;
    common: {};
    /**
     * 内置方法
     */
    setState: (state: any) => void;
}
export declare function removeGlboalApi(): void;
export interface IPageAPI extends IBaseState {
    __internal__?: {
        $w?: any;
        active: boolean;
        packageName?: string;
    };
    $page?: IPageAPI;
    id?: string;
    uuid?: string;
    handler: {
        [key: string]: any;
    };
    widgets: {
        [key: string]: any;
    };
    setState: (state: any) => void;
    setParams: (params: any) => void;
    /**
     * @deprecated
     */
    invokeComponentMethod: (props: {
        component: string | UserWidget;
        method: string;
        params: any;
    }) => any;
    _dataBinds: {
        [key: string]: any;
    };
}
export declare function createPageApi(): IPageAPI;
export interface ICompositeComponentAPI extends IBaseState {
    __internal__?: {
        $w?: any;
        defaultCssUnit?: 'rpx' | 'rem' | 'px';
    };
    id: string;
    handler?: {
        [key: string]: any;
    };
    props: {
        [key: string]: any;
    };
    widgets?: {
        [key: string]: any;
    };
    _dataBinds?: {
        [key: string]: any;
    };
    _instanceRef: {
        current: any;
    };
    compConfig?: any;
}
export declare function createCompApi({ id, ref, state, computed, _dataBinds, compConfig, node, events, props, handler, propsData, eventFlows, }: {
    id: any;
    ref: any;
    state?: import("mobx").IObservableObject;
    computed?: {};
    _dataBinds?: {};
    compConfig?: {};
    node: any;
    events: any;
    props: any;
    handler?: {};
    propsData: any;
    eventFlows: any;
}): ICompositeComponentAPI;
export {};
