"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomRouter = exports.useLocation = exports.Routes = exports.Navigate = exports.Route = void 0;
const tslib_1 = require("tslib");
// @ts-nocheck
// "react-router-dom": "^6.15.0",
const React = tslib_1.__importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
var react_router_dom_2 = require("react-router-dom");
Object.defineProperty(exports, "Route", { enumerable: true, get: function () { return react_router_dom_2.Route; } });
Object.defineProperty(exports, "Navigate", { enumerable: true, get: function () { return react_router_dom_2.Navigate; } });
Object.defineProperty(exports, "Routes", { enumerable: true, get: function () { return react_router_dom_2.Routes; } });
Object.defineProperty(exports, "useLocation", { enumerable: true, get: function () { return react_router_dom_2.useLocation; } });
function CustomRouter({ basename, children, future, history, }) {
    let [state, setStateImpl] = React.useState({
        action: history.action,
        location: history.location,
    });
    let { v7_startTransition } = future || {};
    let setState = React.useCallback((newState) => {
        v7_startTransition && React['startTransition']
            ? React['startTransition'](() => setStateImpl(newState))
            : setStateImpl(newState);
    }, [setStateImpl, v7_startTransition]);
    React.useLayoutEffect(() => {
        history.listen(() => {
            console.log('history change', history);
            setState({ action: history.action, location: history.location });
        });
    }, [history, setState]);
    return (React.createElement(react_router_dom_1.Router, { basename: basename, location: state.location, navigationType: state.action, navigator: history }, children));
}
exports.CustomRouter = CustomRouter;
/**
 * 问题在于，如果 Route.Component，Route.element 传入函数或 react.createElement(xxx) , 则函数变化时 pagerender 就会 remount
 * 但如果传入element 但是不变化，里面更新就有问题
 */
/* <CustomRouter history={history}>
  <React.Suspense fallback={<Loading />}>
    <Routes>
      {home && <Route path={`/${home.root || ''}`} element={<Navigate to={home.path} replace={true} />} />}
      {routes.map((route) => {
        return <Route key={route.path} path={route.path} Component={route.render} />;
      })}
      <Route path="*" element={<NotFound onNotFound={onNotFound} />}></Route>
    </Routes>
  </React.Suspense>
</CustomRouter>; */
//# sourceMappingURL=router6.js.map