"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeGlobalVar = exports.initGlobalDataset = exports.initGlobalVar = void 0;
/* eslint-disable no-restricted-syntax */
const global_api_1 = require("../app/global-api");
const computed_1 = require("./computed");
const mobx_1 = require("mobx");
const weda_client_1 = require("@cloudbase/weda-client");
const adapter_1 = require("./adapter");
const { createDataset } = weda_client_1._WEDA_CLOUD_SDK;
// 防止页面重复引用
let isInit = false;
let datasetInited = false;
let lowcodeDefinedVarInited = false;
function initGlobalVar({ common, state, computedFuncs, dataset = undefined }, initAppAPI = (app) => { }) {
    adapter_1.runtime['$$global'] = adapter_1.runtime['$$global'] || {};
    initGlobalVarFromLowcode({ common, state, computedFuncs });
    initGlobalDataset(dataset);
    if (!global_api_1.app.state.dataset) {
        global_api_1.app.state.dataset = global_api_1.app.dataset;
    }
    if (!isInit) {
        /**
         * 对 app 上方法进行覆盖
         */
        initAppAPI === null || initAppAPI === void 0 ? void 0 : initAppAPI(global_api_1.app);
        /**
         * 覆盖之后使用新方法更新值
         */
        const { isMobile, $w } = (global_api_1.app === null || global_api_1.app === void 0 ? void 0 : global_api_1.app.__internal__) || {};
        // 应用信息
        if ($w === null || $w === void 0 ? void 0 : $w.wedaContext) {
            const extra = (isMobile === null || isMobile === void 0 ? void 0 : isMobile()) ? ['MOBILE', 'MOBILEWEB'] : ['PCWEB'];
            $w.wedaContext.platforms = ($w.wedaContext.platforms
                ? $w.wedaContext.platforms.filter((item) => item !== 'MOBILEWEB' && item !== 'PCWEB' && item !== 'MOBILE')
                : ['WEB']).concat(extra);
        }
    }
}
exports.initGlobalVar = initGlobalVar;
let GLOBAL_DATASET_SYNC_DISPOSES = [];
function initGlobalDataset(dataset = undefined, force = false) {
    if (!datasetInited || force) {
        const _dataset = dataset || createDataset('$global', undefined, { appId: global_api_1.app.id });
        GLOBAL_DATASET_SYNC_DISPOSES.forEach((dispose) => {
            dispose === null || dispose === void 0 ? void 0 : dispose();
        });
        GLOBAL_DATASET_SYNC_DISPOSES = [];
        global_api_1.app.dataset = _dataset;
        GLOBAL_DATASET_SYNC_DISPOSES = (0, computed_1.watchAndSyncDatasetState2Local)(global_api_1.app.id, '$global', global_api_1.app.dataset.state);
    }
    return global_api_1.app.dataset;
}
exports.initGlobalDataset = initGlobalDataset;
function initGlobalVarFromLowcode({ common, state, computedFuncs }) {
    if (!lowcodeDefinedVarInited) {
        global_api_1.app.common = common;
        global_api_1.app.state = (0, mobx_1.observable)(state);
        global_api_1.app.computed = (0, computed_1.createComputed)(computedFuncs);
    }
}
function removeGlobalVar() {
    isInit = false;
    datasetInited = false;
    lowcodeDefinedVarInited = false;
    adapter_1.runtime['$$global'] = undefined;
}
exports.removeGlobalVar = removeGlobalVar;
//# sourceMappingURL=initGlobalVar.js.map