"use strict";
var _Query_instances, _Query_schema, _Query_context, _Query_triggered, _Query_initedResolver, _Query_disposes, _Query_dataBinds, _Query_action, _Query_paramsRef, _Query_emit, _Query_currentRequestKey, _Query_observableValue, _Query_runQueryMap, _Query_innerTrigger, _Query_debounceTrigger, _Query_resolveParams, _Query_isRunQueryType_get;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Query = void 0;
const tslib_1 = require("tslib");
const cals_1 = require("@cloudbase/cals");
const mobx_1 = require("mobx");
const generate_1 = require("./adapter/generate");
const runtime_1 = require("./runtime");
const lodash_es_1 = require("lodash-es");
var EQUERY_PARAM_TYPE;
(function (EQUERY_PARAM_TYPE) {
    EQUERY_PARAM_TYPE["ARRAY"] = "ARRAY";
    EQUERY_PARAM_TYPE["BOOLEAN"] = "BOOLEAN";
    EQUERY_PARAM_TYPE["NUMBER"] = "NUMBER";
    EQUERY_PARAM_TYPE["OBJECT"] = "OBJECT";
    EQUERY_PARAM_TYPE["STRING"] = "STRING";
})(EQUERY_PARAM_TYPE || (EQUERY_PARAM_TYPE = {}));
var QUERY_RESOURCE;
(function (QUERY_RESOURCE) {
    QUERY_RESOURCE["SQL"] = "mysql-plugin";
    QUERY_RESOURCE["SQLSERVER"] = "mssql-plugin";
    QUERY_RESOURCE["CLOUDCONNECTOR"] = "apis-plugin";
})(QUERY_RESOURCE || (QUERY_RESOURCE = {}));
var QUERY_PATH;
(function (QUERY_PATH) {
    QUERY_PATH["SQL"] = "/WeDa/Query/V1/RunPluginQuery";
    QUERY_PATH["SQLSERVER"] = "/WeDa/Query/V1/RunPluginQuery";
    QUERY_PATH["CLOUDCONNECTOR"] = "/WeDa/Connector/v1/RunApisQuery";
})(QUERY_PATH || (QUERY_PATH = {}));
const KEYS = ['id', 'label', 'description', 'data', 'error', 'isFetching', 'trigger', 'reset'];
class Query {
    constructor({ schema, context, options, }) {
        var _a;
        _Query_instances.add(this);
        _Query_schema.set(this, void 0);
        _Query_context.set(this, void 0);
        _Query_triggered.set(this, false);
        _Query_initedResolver.set(this, (value) => { });
        _Query_disposes.set(this, []);
        _Query_dataBinds.set(this, {});
        _Query_action.set(this, void 0);
        _Query_paramsRef.set(this, (0, mobx_1.observable)({ current: null }));
        _Query_emit.set(this, void 0);
        _Query_currentRequestKey.set(this, null);
        _Query_observableValue.set(this, (0, mobx_1.observable)({
            data: null,
            error: null,
            isFetching: false,
            profile: null,
        }));
        _Query_runQueryMap.set(this, {
            sql: { QueryResource: QUERY_RESOURCE.SQL, QueryPath: QUERY_PATH.SQL },
            sqlserver: { QueryResource: QUERY_RESOURCE.SQLSERVER, QueryPath: QUERY_PATH.SQLSERVER },
            'cloud-connector': { QueryResource: QUERY_RESOURCE.CLOUDCONNECTOR, QueryPath: QUERY_PATH.CLOUDCONNECTOR },
        });
        _Query_debounceTrigger.set(this, (0, lodash_es_1.debounce)(tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_innerTrigger), 300));
        const { looseError = false, useScopeWidgetData = false, isComposite } = options;
        const { $w, $app, $page } = context;
        tslib_1.__classPrivateFieldSet(this, _Query_schema, (0, cals_1.normalizeQuery)(schema), "f");
        tslib_1.__classPrivateFieldSet(this, _Query_context, context, "f");
        this.initPromise = new Promise((resolve) => {
            tslib_1.__classPrivateFieldSet(this, _Query_initedResolver, resolve, "f");
        });
        if (((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.trigger) === 'auto') {
            tslib_1.__classPrivateFieldGet(this, _Query_disposes, "f").push((0, mobx_1.autorun)((r) => {
                var _a;
                // r.trace(true);
                try {
                    const data = tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_resolveParams).call(this, {}, { combainErrors: true });
                    if (((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.type) === cals_1.EQueryType.GeneralFunc) {
                        // 因为要收集依赖，因此不能 debounce
                        tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_innerTrigger).call(this, data);
                    }
                    else if (tslib_1.__classPrivateFieldGet(this, _Query_triggered, "f")) {
                        tslib_1.__classPrivateFieldGet(this, _Query_debounceTrigger, "f").call(this, data);
                    }
                }
                catch (e) {
                    console.error(e);
                }
                finally {
                    tslib_1.__classPrivateFieldGet(this, _Query_initedResolver, "f").call(this, true);
                }
            }, { delay: 50 }));
        }
        else {
            tslib_1.__classPrivateFieldGet(this, _Query_initedResolver, "f").call(this, true);
        }
        const deserializeContext = ($page === null || $page === void 0 ? void 0 : $page.id)
            ? {
                page: { id: $page.id, type: cals_1.EComponentType.PAGE },
            }
            : {};
        const processedParams = (0, cals_1.deserializeDynamicMap)(deserializeContext, (0, cals_1.generateHandlerParamsDynamicMap)(tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").handler));
        const { staticData, dataBinds = [] } = (0, generate_1.splitDynamicMap)(processedParams);
        tslib_1.__classPrivateFieldGet(this, _Query_paramsRef, "f").current = staticData;
        tslib_1.__classPrivateFieldSet(this, _Query_dataBinds, (0, generate_1.generateDataBinds)({ $page, $app }, dataBinds === null || dataBinds === void 0 ? void 0 : dataBinds.filter((item) => {
            return !/[\s+\-*/!&|%]*?SERVER\./.test(item.propertyPath);
        }), Object.assign(Object.assign({ looseError,
            useScopeWidgetData }, options), { key: `${this.id} method.params` })), "f");
        const generalFunQuery = function (data, options = {}, additionalScope) {
            var _a, _b, _c;
            return tslib_1.__awaiter(this, void 0, void 0, function* () {
                let { debug = false } = options;
                let start = Date.now();
                const innerFunction = new window.Function('__data__,__params__,$w', `${isComposite ? 'const $comp = $w.$comp;' : ''}
        return (\n${((_c = (_b = (_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").handler) === null || _a === void 0 ? void 0 : _a[':code']) === null || _b === void 0 ? void 0 : _b.replace) === null || _c === void 0 ? void 0 : _c.call(_b, /;\s*$/, '')) || '()=>{}'}\n)({params:__params__,data:__data__})`);
                let result = yield innerFunction(data, additionalScope, $w);
                const profile = {
                    requestTimeCost: Date.now() - start,
                };
                return {
                    profile: debug ? profile : undefined,
                    value: result,
                };
            });
        };
        const runQueryType = function (data, options = {}) {
            return tslib_1.__awaiter(this, void 0, void 0, function* () {
                let { debug = false } = options;
                const requestData = {
                    EnvId: $w.env.envId,
                    Name: data.sqlTemplateId,
                    Parameter: JSON.stringify(Object.entries(data.params || {}).reduce((list, [key, value]) => {
                        if (value !== undefined) {
                            let type = EQUERY_PARAM_TYPE.OBJECT;
                            const typeofValue = typeof value;
                            switch (typeofValue) {
                                case 'boolean': {
                                    type = EQUERY_PARAM_TYPE.BOOLEAN;
                                    break;
                                }
                                case 'number': {
                                    type = EQUERY_PARAM_TYPE.NUMBER;
                                    break;
                                }
                                case 'string': {
                                    type = EQUERY_PARAM_TYPE.STRING;
                                    break;
                                }
                                default: {
                                    if (Array.isArray(value)) {
                                        type = EQUERY_PARAM_TYPE.ARRAY;
                                    }
                                    else {
                                        type = EQUERY_PARAM_TYPE.OBJECT;
                                    }
                                }
                            }
                            list.push({
                                Key: key,
                                Type: type,
                                Value: type === EQUERY_PARAM_TYPE.STRING ? value : JSON.stringify(value),
                            });
                        }
                        return list;
                    }, []) || []),
                };
                let start = Date.now();
                const Data = yield $w.cloud.callWedaApi(Object.assign(Object.assign({ action: 'RunQuery', CallQuery: true }, (tslib_1.__classPrivateFieldGet(this, _Query_runQueryMap, "f")[tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").type] || tslib_1.__classPrivateFieldGet(this, _Query_runQueryMap, "f")[cals_1.EQueryType.Sql])), { EnvId: requestData.EnvId, QueryName: requestData.Name, data: requestData, BackendLatency: !!debug }));
                // const Data = await $w.cloud.callWedaApi({
                //   action: 'RunPluginQuery',
                //   data: { MainAppId: $w.app.id, ...requestData },
                // });
                const { ExecuteResultList = [], Total, BackendExecute, BackendLatency, Payload } = Data || {};
                const content = ExecuteResultList.join('');
                const profile = {
                    backendExecude: Number(BackendExecute || 0),
                    backendLatency: Number(BackendLatency || 0),
                    /**
                     * 中文时有问题
                     * 但是不太关键，别用于关键逻辑判断
                     */
                    contentLength: content.length,
                    requestTimeCost: Date.now() - start,
                };
                try {
                    const encoder = new TextEncoder();
                    const bytes = encoder.encode(content);
                    profile.contentLength = bytes.length;
                }
                catch (e) { }
                let payload = Payload;
                try {
                    if (Payload) {
                        payload = JSON.parse(Payload);
                    }
                }
                catch (e) { }
                return {
                    profile: debug ? profile : undefined,
                    value: tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").type === cals_1.EQueryType.CloudConnector
                        ? payload
                        : {
                            records: ExecuteResultList.map((item) => JSON.parse(item)),
                            total: Total || ExecuteResultList.length,
                        },
                };
            });
        };
        tslib_1.__classPrivateFieldSet(this, _Query_action, function (data, options, additionalScope) {
            var _a;
            return tslib_1.__awaiter(this, void 0, void 0, function* () {
                const errorHandler = function (data) {
                    throw new Error('Invalue query handler');
                };
                return tslib_1.__classPrivateFieldGet(this, _Query_instances, "a", _Query_isRunQueryType_get)
                    ? runQueryType.call(this, data, options)
                    : tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").type === cals_1.EQueryType.GeneralFunc
                        ? generalFunQuery.call(this, data, options, additionalScope)
                        : { value: yield ((0, lodash_es_1.get)($w.app, (_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").handler) === null || _a === void 0 ? void 0 : _a.name).call(this, data) || errorHandler(data)) };
            });
        }, "f");
        tslib_1.__classPrivateFieldSet(this, _Query_emit, (trigger, eventData, originalEvent) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            var _b;
            return (0, runtime_1.generateEmit)($w)(trigger, (0, generate_1.generateListnerInstances)({
                $app,
                $page,
                actionsMap: tslib_1.__classPrivateFieldGet(this, _Query_context, "f").actionsMap,
            }, tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").listeners || [], options), eventData, {}, originalEvent, {}, {}, 
            /**
             * 当 app 全局情况下
             * 不进行 pageId 判断
             */
            (_b = $w.page) === null || _b === void 0 ? void 0 : _b.id, true);
        }), "f");
        return this;
    }
    get id() {
        var _a;
        return ((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.id) || '';
    }
    get label() {
        var _a;
        return ((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.label) || '';
    }
    get description() {
        var _a;
        return ((_a = tslib_1.__classPrivateFieldGet(this, _Query_schema, "f")) === null || _a === void 0 ? void 0 : _a.description) || '';
    }
    get data() {
        return tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").data;
    }
    get error() {
        return tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").error;
    }
    get isFetching() {
        return tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching;
    }
    trigger(additionalScope, options) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            tslib_1.__classPrivateFieldSet(this, _Query_triggered, true, "f");
            let start = Date.now();
            const resolvedParams = tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_resolveParams).call(this, additionalScope);
            const resolveParamsTimecost = Date.now() - start;
            const res = yield tslib_1.__classPrivateFieldGet(this, _Query_instances, "m", _Query_innerTrigger).call(this, resolvedParams, options, additionalScope);
            if (res === null || res === void 0 ? void 0 : res.profile) {
                res.profile = Object.assign(Object.assign({}, res.profile), { trrigerTimeCost: Date.now() - start, resolveParamsTimecost });
            }
            return res;
        });
    }
    reset() {
        tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").data = null;
        tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").error = null;
        tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching = false;
    }
    destroy() {
        tslib_1.__classPrivateFieldGet(this, _Query_disposes, "f").forEach((dispose) => dispose());
    }
    /**
     * 用于调试
     */
    _toSchema() {
        console.warn('调试使用，结构可能发生更改，请不要用于生产环境');
        return tslib_1.__classPrivateFieldGet(this, _Query_schema, "f");
    }
    toJSON() {
        return KEYS.reduce((obj, key) => {
            obj[key] = this[key];
            return obj;
        }, {});
    }
}
exports.Query = Query;
_Query_schema = new WeakMap(), _Query_context = new WeakMap(), _Query_triggered = new WeakMap(), _Query_initedResolver = new WeakMap(), _Query_disposes = new WeakMap(), _Query_dataBinds = new WeakMap(), _Query_action = new WeakMap(), _Query_paramsRef = new WeakMap(), _Query_emit = new WeakMap(), _Query_currentRequestKey = new WeakMap(), _Query_observableValue = new WeakMap(), _Query_runQueryMap = new WeakMap(), _Query_debounceTrigger = new WeakMap(), _Query_instances = new WeakSet(), _Query_innerTrigger = function _Query_innerTrigger(args, options, additionalScope) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        tslib_1.__classPrivateFieldSet(this, _Query_currentRequestKey, Date.now(), "f");
        const key = tslib_1.__classPrivateFieldGet(this, _Query_currentRequestKey, "f");
        try {
            tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching = true;
            const actionArgs = [args === null || args === void 0 ? void 0 : args[0]];
            actionArgs.push(options, additionalScope);
            const { profile, value: res } = yield tslib_1.__classPrivateFieldGet(this, _Query_action, "f").call(this, ...actionArgs);
            if (key === tslib_1.__classPrivateFieldGet(this, _Query_currentRequestKey, "f")) {
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching = false;
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").data = res;
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").error = null;
                tslib_1.__classPrivateFieldGet(this, _Query_emit, "f").call(this, `success`, res);
            }
            return profile ? Object.assign(Object.assign({}, (res instanceof Object ? res : { value: res })), { profile }) : res;
        }
        catch (e) {
            if (key === tslib_1.__classPrivateFieldGet(this, _Query_currentRequestKey, "f")) {
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").isFetching = false;
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").data = null;
                tslib_1.__classPrivateFieldGet(this, _Query_observableValue, "f").error = e;
                tslib_1.__classPrivateFieldGet(this, _Query_emit, "f").call(this, `fail`, e);
            }
            throw e;
        }
    });
}, _Query_resolveParams = function _Query_resolveParams(additionalScope = {}, options) {
    /**
     * 这里万一其中某个字段计算失败
     * 好像会阻塞其他字段的计算
     * 从而导致 autorun 没有添加依赖
     */
    let { params = [] } = (0, runtime_1.mergeDynamic2StaticData)((0, mobx_1.toJS)(tslib_1.__classPrivateFieldGet(this, _Query_paramsRef, "f").current), tslib_1.__classPrivateFieldGet(this, _Query_dataBinds, "f"), {
        $w: tslib_1.__classPrivateFieldGet(this, _Query_context, "f").$w,
        paramsContext: additionalScope,
    }, options === null || options === void 0 ? void 0 : options.combainErrors) || {};
    return params;
}, _Query_isRunQueryType_get = function _Query_isRunQueryType_get() {
    return !!tslib_1.__classPrivateFieldGet(this, _Query_runQueryMap, "f")[tslib_1.__classPrivateFieldGet(this, _Query_schema, "f").type];
};
//# sourceMappingURL=query.js.map